﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Media.Imaging;
using System.Runtime.InteropServices.Automation;

namespace ElevatedMode
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (App.Current.IsRunningOutOfBrowser && App.Current.HasElevatedPermissions)
            {
                BdrTitle.Visibility = Visibility.Visible;
                rctResize.Visibility = Visibility.Visible;
                SetPicture();

                if (AutomationFactory.IsAvailable) {
                    spElevated.Visibility = Visibility.Visible;
                }
            }
        }

        private void DragBottomRight(object sender, MouseButtonEventArgs e)
        {
            if (App.Current.IsRunningOutOfBrowser &&
                App.Current.HasElevatedPermissions)
            {
                App.Current.MainWindow.DragResize
                           (WindowResizeEdge.BottomRight);
            }
        }

        // Dragging the main window
        private void DragWindow(object sender, MouseButtonEventArgs e)
        {
                Application.Current.MainWindow.DragMove();
              //  Application.Current.MainWindow.TopMost = true;
        }

        // minimize the window
        private void btnMini(object sender, RoutedEventArgs e)
        {
            App.Current.MainWindow.WindowState = WindowState.Minimized;
        }

        // close the window
        private void btnClose(object sender, RoutedEventArgs e)
        {
            Application.Current.MainWindow.Close();
        }

        private void SetPicture()
        {

             // get  the first png or jpg image from the MyPictures folder
            string path = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures);
            DirectoryInfo m_Directory = new DirectoryInfo(path);
            FileInfo _f =  m_Directory.EnumerateFiles()
                          .Where(p => p.Extension.ToLower().Contains(".jpg") ||
                                      p.Extension.ToLower().Contains(".png")).FirstOrDefault();

            if (_f != null)
            {
                using (FileStream stream = File.Open(_f.FullName, FileMode.Open))
                {
                    BitmapImage bi = null;
                    bi = new BitmapImage();
                    bi.SetSource(stream);
                    imgpic.Source = bi;
                }
            }
        }

        private void btnCalc_Click(object sender, RoutedEventArgs e)
        {
            using (dynamic _ComObj = AutomationFactory.CreateObject("WScript.Shell"))
            {
                _ComObj.Run(@"c:\windows\system32\calc.exe");
            }

        }

        private void btnExcel_Click(object sender, RoutedEventArgs e)
        {
            if (AutomationFactory.IsAvailable)
            {
                using (dynamic _excel = AutomationFactory.CreateObject("Excel.Application"))
                {
                    _excel.Visible = true;
                    dynamic workbook = _excel.workbooks;
                    workbook.Add();
                    dynamic sheet = _excel.ActiveSheet;
                    dynamic range;
                    range = sheet.Range("A1");
                    range.Value = "Populated From Silverlight";
                    range = sheet.Range("A2");
                    range.Value = "10000";
                    range = sheet.Range("A3");
                    range.Value = "20000";
                    range = sheet.Range("A4");
                    range.Formula = "=@Sum(A2..A3)";
                    range.Calculate();
                }

                // Clipboard API
                Clipboard.SetText("I can also Paste from the Silverlight ClipBoard");
            }
        }
    }
}
