﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.IO;

namespace ElevatedMode.ViewModels
{
    public class FileExplorerViewModel : INotifyPropertyChanged
    {

        #region private members
        private FileInfo m_SelectedFile;
        private DirectoryInfo m_SelectedDirectory;
        #endregion

        

        public ObservableCollection<FileInfo> Files { get; set; }
        public ObservableCollection<DirectoryInfo> Directories { get; set; }

        private FileInfo SelectedFile
        {
            get { return m_SelectedFile; }
            set
            {
                if (m_SelectedFile!=value) {
                    m_SelectedFile = value;
                    OnPropertyChanged("SelectedFile");
                }
            }
        }

        private DirectoryInfo SelectedDirectory
        {
            get { return m_SelectedDirectory; }
            set
            {
                if (m_SelectedDirectory != value)
                {
                    m_SelectedDirectory = value;
                    OnPropertyChanged("SelectedDirectory");
                }
            }
        }

        #region propertychanged
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }
}
